INSERT OPENQUERY(venabo, 
'SELECT
	   id
      ,hash
      ,created_at
      ,created_by
      ,updated_at
      ,updated_by
      ,deleted_at
      ,deleted_by
 FROM license_hash'
)

SELECT [id]
      ,[hash]
      ,[createdAt]
      ,[createdBy]
      ,[updatedAt]
      ,[updatedBy]
      ,[deletedAt]
      ,[deletedBy]
  FROM [dbo].[license_hash]



--Wichtig! Hier die Kundennummer vom Eigenbedarfskunden rein
update SCORE.[dbo].[time_entry]
set customerId = 740
WHERE ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) IS NULL  

GO

print('----Next Table object_type ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, parent_id, article_group_id, name, files
FROM object_type'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([parentId] AS bigint),NULL) AS [parentId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[article_group] WHERE [id] = [articleGroupId]) AS nvarchar(26)),NULL) AS [articleGroupId],
ISNULL(CAST([name] AS nvarchar(256)),NULL) AS [name],
ISNULL(CAST([files] AS tinyint),NULL) AS [files]
FROM
SCORE.[dbo].[object_type]
order by ISNULL(CAST([parentId] AS bigint),NULL), id;
GO

print('----Next Table object_type_field ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, object_type_id, name, autofill_field, data, required, secured, type, sort
FROM object_type_field'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([objectTypeId] AS bigint),NULL) AS [objectTypeId],
ISNULL(CAST([name] AS nvarchar(256)),NULL) AS [name],
ISNULL(CAST([autofillField] AS nvarchar(256)),NULL) AS [autofillField],
ISNULL(CAST([data] AS nvarchar(4000)),NULL) AS [data],
ISNULL(CAST([required] AS tinyint),NULL) AS [required],
ISNULL(CAST([secured] AS tinyint),NULL) AS [secured],
ISNULL(CAST([type] AS nvarchar(256)),NULL) AS [type],
ISNULL(CAST([sort] AS bigint),NULL) AS [sort]
FROM
SCORE.[dbo].[object_type_field];
GO


print('----Next Table country ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name
FROM country'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name]
FROM
SCORE.[dbo].[country];
GO

print('----Next Table state ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, country_id, name
FROM state'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([countryId] AS bigint),NULL) AS [countryId],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name]
FROM
SCORE.[dbo].[state];
GO

print('----Next Table user ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, login, email, salt, password, active, token, token_expiration_date,   deleted_at, "type"
FROM public.user'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([login] AS nvarchar(128)),NULL) AS [login],
ISNULL(CAST([email] AS nchar(256)),NULL) AS [email],
ISNULL(CAST([salt] AS nvarchar(256)),NULL) AS [salt],
ISNULL(CAST([password] AS nvarchar(256)),NULL) AS [password],
ISNULL(CAST([active] AS bit),1) AS [active],
ISNULL(CAST([token] AS nvarchar(64)),NULL) AS [token],
ISNULL(CAST([tokenExpirationDate] AS date),NULL) AS [tokenExpirationDate],
ISNULL(CAST([deletedAt] AS datetime),NULL) AS [deletedAt],
'USER' as [type]
FROM
SCORE.[dbo].[user];
GO

print('----Next Table employee ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, external_id, first_name, last_name, initials, email, active, trainee, temporary, ignore_worktime_stats, cti_user_name, deleted_at, deleted_by, staff_number, street, zip, city, phone_number, mobile_number, birthday, image_data, worktime_calc_scheme, refreshing_stamps
FROM employee'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
(SELECT [venaboId] FROM [middleware].[dbo].[external_employee] WHERE id = ISNULL(CAST([externalId] AS int),NULL)) AS [externalId],
ISNULL(CAST([firstName] AS nvarchar(4000)),NULL) AS [firstName],
ISNULL(CAST([lastName] AS nvarchar(4000)),NULL) AS [lastName],
ISNULL(CAST([initials] AS nvarchar(4000)),NULL) AS [initials],
ISNULL(CAST([email] AS nvarchar(4000)),NULL) AS [email],
ISNULL(CAST([active] AS tinyint),NULL) AS [active],
ISNULL(CAST([trainee] AS tinyint),NULL) AS [trainee],
ISNULL(CAST([temporary] AS tinyint),NULL) AS [temporary],
ISNULL(CAST([ignoreWorktimeStats] AS tinyint),NULL) AS [ignoreWorktimeStats],
ISNULL(CAST([ctiUserName] AS nvarchar(4000)),NULL) AS [ctiUserName],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([staffNumber] AS nvarchar(4000)),NULL) AS [staffNumber],
ISNULL(CAST([street] AS nvarchar(4000)),NULL) AS [street],
ISNULL(CAST([zip] AS nvarchar(4000)),NULL) AS [zip],
ISNULL(CAST([city] AS nvarchar(4000)),NULL) AS [city],
ISNULL(CAST([phoneNumber] AS nvarchar(4000)),NULL) AS [phoneNumber],
ISNULL(CAST([mobileNumber] AS nvarchar(4000)),NULL) AS [mobileNumber],
ISNULL(CAST([birthday] AS datetime2),NULL) AS [birthday],
ISNULL(CAST([imageData] AS varchar(4000)),NULL) AS [imageData],
ISNULL(CAST([worktimeCalcScheme] AS nvarchar(4000)),NULL) AS [worktimeCalcScheme],
ISNULL(CAST([refreshingStamps] AS bit),NULL) AS [refreshingStamps]
FROM
SCORE.[dbo].[employee];
GO

update oq
set oq.cf_old = cast(cast(ad.customFields as nvarchar(max)) as text)
--set oq.custom_fields = NULL
from OPENQUERY(venabo, 
'SELECT
*
FROM employee'
) oq
left outer join SCORE.[dbo].[employee] ad on ad.id = oq.id
where ad.customFields is not null;
GO

print('----Next Table group ---');
DELETE FROM OPENQUERY(venabo, 
'SELECT
*
FROM public."group"'
);
GO

print('----Next Table group ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name
FROM public."group"'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(256)),NULL) AS [name]
FROM
SCORE.[dbo].[group];
GO

print('----Next Table group_permission ---');
INSERT OPENQUERY(venabo, 
'SELECT
group_id, permission_id
FROM group_permission'
)
SELECT
ISNULL(CAST([groupId] AS bigint),NULL) AS [groupId],
ISNULL(CAST(vp.[id] AS bigint),NULL) AS [permissionId]
FROM
SCORE.[dbo].[group_permission] gp
left outer join SCORE.[dbo].[permission] p on gp.permissionId = p.id
left outer join (Select * from OPENQUERY(venabo, 'SELECT * FROM permission')) as vp on vp.[role] collate Latin1_General_CS_AS = p.[role] collate Latin1_General_CS_AS
;
GO

print('----Next Table user_details ---');
INSERT OPENQUERY(venabo, 
'SELECT
user_id, group_id, name, employee_id, auto_subscription, color_code, mail_receiver, text_color, image, updated_at
FROM user_details'
)
SELECT
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([groupId] AS bigint),NULL) AS [groupId],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([autoSubscription] AS bit),NULL) AS [autoSubscription],
ISNULL(CAST([colorCode] AS nvarchar(510)),NULL) AS [colorCode],
ISNULL(CAST([mailReceiver] AS bit),NULL) AS [mailReceiver],
ISNULL(CAST(ud.[textColor] AS nvarchar(510)),NULL) AS [textColor],
ISNULL(CAST(ud.[image] AS nvarchar(510)),NULL) AS [image],
ISNULL(CAST(ud.[updatedAt] AS datetime2),NULL) AS [updatedAt]
FROM
SCORE.[dbo].[user_details] ud
INNER JOIN SCORE.dbo.[user] u on u.id = ud.userId;
GO


print('----Next Table status ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name_de, name_en, type, sequence, icon, completes_ticket, completes_project, ticket_status, project_status, completes_process, process_status, campaign_status, completes_campaign
FROM status'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name_de] AS nvarchar(128)),NULL) AS [name_de],
ISNULL(CAST([name_en] AS nvarchar(128)),NULL) AS [name_en],
ISNULL(CAST([type] AS nvarchar(32)),NULL) AS [type],
ISNULL(CAST([sequence] AS int),NULL) AS [sequence],
ISNULL(CAST([icon] AS nvarchar(128)),NULL) AS [icon],
ISNULL(CAST([completesTicket] AS tinyint),0) AS [completesTicket],
ISNULL(CAST([completesProject] AS tinyint),0) AS [completesProject],
ISNULL(CAST([ticketStatus] AS tinyint),0) AS [ticketStatus],
ISNULL(CAST([projectStatus] AS tinyint),0) AS [projectStatus],
ISNULL(CAST([completesProcess] AS tinyint),0) AS [completesProcess],
ISNULL(CAST([processStatus] AS tinyint),0) AS [processStatus],
ISNULL(CAST([campaignStatus] AS bit),0) AS [campaignStatus],
ISNULL(CAST([completesCampaign] AS bit),0) AS [completesCampaign]
FROM
SCORE.[dbo].[status];
GO


print('----Next Table sync_time ---');
INSERT OPENQUERY(venabo, 
'SELECT
identifier, time
FROM sync_time'
)
SELECT
ISNULL(CAST([identifier] AS varchar(255)),NULL) AS [identifier],
ISNULL(CAST([time] AS datetime2),NULL) AS [time]
FROM
SCORE.[dbo].[sync_time];
GO


print('----Next Table tag ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, description, parent_id, active, types, folder
FROM tag'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([description] AS nvarchar(510)),NULL) AS [description],
ISNULL(CAST([parentId] AS bigint),NULL) AS [parentId],
ISNULL(CAST([active] AS tinyint),0) AS [active],
ISNULL(CAST([types] AS varchar(4000)),NULL) AS [types],
ISNULL(CAST([folder] AS bit),0) AS [folder]
FROM
SCORE.[dbo].[tag]
order by case when [parentId] is not null then id else [parentId] end ;
GO


print('----Next Table category ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, parent_id, sequence, process, campaign, report, uploaded_file
FROM category'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([parentId] AS bigint),NULL) AS [parentId],
ISNULL(CAST([sequence] AS int),NULL) AS [sequence],
ISNULL(CAST([process] AS bit),0) AS [process],
ISNULL(CAST([campaign] AS bit),0) AS [campaign],
ISNULL(CAST([report] AS bit),0) AS [report],
ISNULL(CAST([uploadedFile] AS bit),0) AS [uploadedFile]
FROM
SCORE.[dbo].[category];
GO

print('----Next Table absence_reason ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, description, color, active, deleted_at, deleted_by, missout_important
FROM absence_reason'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([description] AS varchar(4000)),NULL) AS [description],
ISNULL(CAST([color] AS nvarchar(510)),NULL) AS [color],
ISNULL(CAST([active] AS bit),0) AS [active],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([missout_important] AS bit),0) AS [missout_important]
FROM
SCORE.[dbo].[absence_reason];
GO

print('----Next Table cronjob ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, command, blocked, active, log, last_execution, next_execution, scheduler, updated_by, updated_at, created_by, created_at, continue_on_error, deleted_at, deleted_by
FROM cronjob'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([command] AS nvarchar(510)),NULL) AS [command],
ISNULL(CAST([blocked] AS bit),0) AS [blocked],
ISNULL(CAST([active] AS bit),0) AS [active],
ISNULL(CAST([log] AS varchar(4000)),NULL) AS [log],
ISNULL(CAST([lastExecution] AS datetime2),NULL) AS [lastExecution],
ISNULL(CAST([nextExecution] AS datetime2),NULL) AS [nextExecution],
ISNULL(CAST([scheduler] AS varchar(4000)),NULL) AS [scheduler],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([continueOnError] AS bit),0) AS [continueOnError],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[cronjob];
GO

print('----Next Table email_template ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, identifier, name, template, updated_by, updated_at,
 default_file
FROM email_template'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([identifier] AS nvarchar(255)),NULL) AS [identifier],
ISNULL(CAST([name] AS nvarchar(255)),NULL) AS [name],
ISNULL(CAST([template] AS nvarchar(4000)),'') AS [template],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([updatedAt] AS date),NULL) AS [updatedAt],
ISNULL(CAST([defaultFile] AS nvarchar(255)),'') AS [defaultFile]
FROM
SCORE.[dbo].[email_template];
GO

print('----Next Table shift ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, active, updated_at, updated_by, created_at, created_by, deleted_at, deleted_by
FROM shift'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([active] AS bit),0) AS [active],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[shift];
GO

print('----Next Table teamviewer_group ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, address_id, created_at
FROM teamviewer_group'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [addressId]) AS bigint),NULL) AS [addressId],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt]
FROM
SCORE.[dbo].[teamviewer_group];
GO


print('----Next Table teamviewer_device ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, group_id, address_id, created_at
FROM teamviewer_device'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([groupId] AS bigint),NULL) AS [groupId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [addressId]) AS bigint),NULL) AS [addressId],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt]
FROM
SCORE.[dbo].[teamviewer_device];
GO


print('----Next Table teamviewer_user ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, employee_id, created_at
FROM teamviewer_user'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt]
FROM
SCORE.[dbo].[teamviewer_user];
GO


print('----Next Table tag_customer_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
tag_id, customer_id
FROM tag_customer_mapping'
)
SELECT
ISNULL(CAST([tagId] AS bigint),NULL) AS [tagId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) AS [customerId]
FROM
SCORE.[dbo].[tag_customer_mapping]
WHERE ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) IS NOT NULL;
GO

print('----Next Table tag_employee_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
tag_id, employee_id
FROM tag_employee_mapping'
)
SELECT
ISNULL(CAST([tagId] AS bigint),NULL) AS [tagId],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId]
FROM
SCORE.[dbo].[tag_employee_mapping];
GO


print('----Next Table teamviewer_connection ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].[teamviewer_connection])
<> (Select count(*) from OPENQUERY(venabo, 'SELECT id FROM teamviewer_connection'))

BEGIN  
INSERT OPENQUERY(venabo, 
'SELECT
id, identifier, user_id, device_id, group_id, start_date, end_date, fee, currency, billing_state, note, created_at, done_at, done_by, auto_closed
FROM teamviewer_connection'
)
SELECT top 10000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([identifier] AS nvarchar(510)),NULL) AS [identifier],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([deviceId] AS bigint),NULL) AS [deviceId],
ISNULL(CAST([groupId] AS bigint),NULL) AS [groupId],
ISNULL(CAST([startDate] AS datetime2),NULL) AS [startDate],
ISNULL(CAST([endDate] AS datetime2),NULL) AS [endDate],
ISNULL(CAST([fee] AS nvarchar(510)),NULL) AS [fee],
ISNULL(CAST([currency] AS nvarchar(510)),NULL) AS [currency],
ISNULL(CAST([billing_state] AS nvarchar(510)),NULL) AS [billing_state],
ISNULL(CAST([note] AS varchar(4000)),NULL) AS [note],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([doneAt] AS datetime2),NULL) AS [doneAt],
ISNULL(CAST([doneBy] AS bigint),NULL) AS [doneBy],
ISNULL(CAST([autoClosed] AS bit),0) AS [autoClosed]
FROM
SCORE.[dbo].[teamviewer_connection]
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM teamviewer_connection'))
order by id desc;
END
GO

print('----Next Table location ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, country, zip_code, longitude, latitude
FROM location'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([country] AS nvarchar(510)),NULL) AS [country],
ISNULL(CAST([zipCode] AS nvarchar(510)),NULL) AS [zipCode],
ISNULL(CAST([longitude] AS float),NULL) AS [longitude],
ISNULL(CAST([latitude] AS float),NULL) AS [latitude]
FROM
SCORE.[dbo].[location];
GO


print('----Next Table address_info ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, address_id, text, created_at, created_by
FROM address_info'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [addressId]) AS bigint),NULL) AS [addressId],
ISNULL(CAST([text] as nvarchar(4000)),NULL) AS [text],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy]
FROM
SCORE.[dbo].[address_info]
WHERE ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [addressId]) AS bigint),NULL) IS NOT NULL;
GO

print('----Next Table address_note ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, address_id, status_id, activity_type_id, text, created_by, created_at
FROM address_note'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [addressId]) AS int),NULL) AS [addressId],
ISNULL(CAST([statusId] AS bigint),NULL) AS [statusId],
ISNULL(CAST([activityTypeId] AS bigint),NULL) AS [activityTypeId],
ISNULL(CAST([text] AS nvarchar(4000)),NULL) AS [text],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt]
FROM
SCORE.[dbo].[address_note];
GO

print('----Next Table customer_details ---');
INSERT OPENQUERY(venabo, 
'SELECT
customer_id, comment, special_case, main_customer_id, default_internal_tickets
FROM customer_details'
)
SELECT
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) AS [customerId],
ISNULL(CAST([comment] AS nvarchar(4000)),NULL) AS [comment],
ISNULL(CAST([specialCase] AS tinyint),NULL) AS [specialCase],
ISNULL(CAST([mainCustomerId] AS int),NULL) AS [mainCustomerId],
ISNULL(CAST([defaultInternalTickets] AS tinyint),NULL) AS [defaultInternalTickets]
FROM
SCORE.[dbo].[customer_details]
WHERE ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) IS NOT NULL;
GO

print('----Next Table timer ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, user_id, data, stored_duration, created_at, activated_at, times
FROM timer'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([data] AS nvarchar(4000)),NULL) AS [data],
ISNULL(CAST([storedDuration] AS int),NULL) AS [storedDuration],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([activatedAt] AS datetime2),NULL) AS [activatedAt],
ISNULL(CAST([times] AS nvarchar(4000)),NULL) AS [times]
FROM
SCORE.[dbo].[timer];
GO


print('----Next Table report ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, data, updated_at, updated_by, created_at, created_by, deleted_at, deleted_by, category_id, child_category_id, query, slug
FROM report'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(255)),NULL) AS [name],
ISNULL(CAST([data] AS varchar(4000)),NULL) AS [data],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([categoryId] AS bigint),NULL) AS [categoryId],
ISNULL(CAST([childCategoryId] AS bigint),NULL) AS [childCategoryId],
ISNULL(CAST([query] AS varchar(4000)),NULL) AS [query],
ISNULL(CAST([slug] AS nvarchar(255)),NULL) AS [slug]
FROM
SCORE.[dbo].[report];
GO

print('----Next Table custom_field ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, owner_type, name, label, type, type_options, encrypted, required, listed, sequence, created_at, created_by, updated_at, updated_by, deleted_at, deleted_by
FROM custom_field'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([ownerType] AS nvarchar(510)),NULL) AS [ownerType],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([label] AS nvarchar(510)),NULL) AS [label],
ISNULL(CAST([type] AS nvarchar(510)),NULL) AS [type],
ISNULL(CAST([typeOptions] AS varchar(4000)),NULL) AS [typeOptions],
ISNULL(CAST([encrypted] AS bit),0) AS [encrypted],
ISNULL(CAST([required] AS bit),0) AS [required],
ISNULL(CAST([listed] AS bit),0) AS [listed],
ISNULL(CAST([sequence] AS int),NULL) AS [sequence],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[custom_field];
GO

print('----Next Table ticket_filter ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, filter, user_id, created_at
FROM ticket_filter'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([filter] AS nvarchar(4000)),NULL) AS [filter],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt]
FROM
SCORE.[dbo].[ticket_filter];
GO

print('----Next Table tag_address_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
tag_id, address_id
FROM tag_address_mapping'
)
SELECT
ISNULL(CAST([tagId] AS bigint),NULL) AS [tagId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [addressId]) AS bigint),NULL) AS [addressId]
FROM
SCORE.[dbo].[tag_address_mapping]
WHERE ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [addressId]) AS bigint),NULL) IS NOT NULL;
GO

print('----Next Table ticket_priority ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name_de, name_en, icon, sequence
FROM ticket_priority'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name_de] AS nvarchar(128)),NULL) AS [name_de],
ISNULL(CAST([name_en] AS nvarchar(128)),NULL) AS [name_en],
ISNULL(CAST([icon] AS nvarchar(128)),NULL) AS [icon],
ISNULL(CAST([sequence] AS int),NULL) AS [sequence]
FROM
SCORE.[dbo].[ticket_priority];
GO

print('----Next Table job ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, class, state, priority, created_at, started_at, closed_at, args, output, runtime
FROM job'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([class] AS nvarchar(510)),NULL) AS [class],
ISNULL(CAST([state] AS nvarchar(510)),NULL) AS [state],
ISNULL(CAST([priority] AS smallint),NULL) AS [priority],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([startedAt] AS datetime2),NULL) AS [startedAt],
ISNULL(CAST([closedAt] AS datetime2),NULL) AS [closedAt],
ISNULL(CAST([args] AS varchar(4000)),NULL) AS [args],
ISNULL(CAST([output] AS varchar(4000)),NULL) AS [output],
ISNULL(CAST([runtime] AS float),NULL) AS [runtime]
FROM
SCORE.[dbo].[job];
GO

print('----Next Table stored_filter ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, owner_type, user_id, name, values, created_at, sorting
FROM stored_filter'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([ownerType] AS nvarchar(510)),NULL) AS [ownerType],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([values] AS varchar(4000)),NULL) AS [values],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([sorting] AS varchar(4000)),NULL) AS [sorting]
FROM
SCORE.[dbo].[stored_filter];
GO

print('----Next Table absence ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, "from", "to", note, half_days, hours, reason_id, deleted_at, deleted_by
FROM absence'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([from] AS date),NULL) AS [from],
ISNULL(CAST([to] AS date),NULL) AS [to],
ISNULL(CAST([note] AS nvarchar(4000)),NULL) AS [note],
ISNULL(CAST([halfDays] AS bit),0) AS [halfDays],
ISNULL(CAST([hours] AS decimal),NULL) AS [hours],
ISNULL(CAST([reasonId] AS bigint),NULL) AS [reasonId],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[absence];
GO

print('----Next Table campaign ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, date, title, description, status_id, category_id, category_child_id, started_at, updated_by, updated_at, created_by, created_at, deleted_by, deleted_at
FROM campaign'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([date] AS datetime2),NULL) AS [date],
ISNULL(CAST([title] AS nvarchar(510)),NULL) AS [title],
ISNULL(CAST([description] AS varchar(4000)),NULL) AS [description],
ISNULL(CAST([statusId] AS bigint),NULL) AS [statusId],
ISNULL(CAST([categoryId] AS bigint),NULL) AS [categoryId],
ISNULL(CAST([categoryChildId] AS bigint),NULL) AS [categoryChildId],
ISNULL(CAST([startedAt] AS datetime2),NULL) AS [startedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt]
FROM
SCORE.[dbo].[campaign];
GO

print('----Next Table dashlet_option ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, dashlet, name, color, data, created_at, created_by, updated_at, updated_by, pinned, deleted_at, deleted_by
FROM dashlet_option'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([dashlet] AS nvarchar(510)),NULL) AS [dashlet],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([color] AS nvarchar(510)),NULL) AS [color],
ISNULL(CAST([data] AS text),NULL) AS [data],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([pinned] AS bit),0) AS [pinned],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[dashlet_option];
GO

print('----Next Table uploaded_file ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].[uploaded_file] uf)
<> (Select count(*) from OPENQUERY(venabo, 'SELECT id FROM uploaded_file')) 
BEGIN  
INSERT OPENQUERY(venabo, 
'SELECT
id, user_id, owner_type, owner_id, filename, size, mime_type, created_at, key, category_id, child_category_id, note
FROM uploaded_file'
)
SELECT top 10000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([ownerType] AS nvarchar(48)),NULL) AS [ownerType],
ISNULL(CAST([ownerId] AS bigint),NULL) AS [ownerId],
ISNULL(CAST([filename] AS nvarchar(510)),NULL) AS [filename],
ISNULL(CAST([size] AS bigint),NULL) AS [size],
ISNULL(CAST([mimeType] AS nvarchar(256)),NULL) AS [mimeType],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([key] AS nvarchar(128)),NULL) AS [key],
ISNULL(CAST([categoryId] AS bigint),NULL) AS [categoryId],
ISNULL(CAST([childCategoryId] AS bigint),NULL) AS [childCategoryId],
ISNULL(CAST([note] AS varchar(4000)),NULL) AS [note]
FROM
SCORE.[dbo].[uploaded_file]
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM uploaded_file'))
order by id desc;
END
GO


print('----Next Table campaign_address_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
campaign_id, address_id
FROM campaign_address_mapping'
)
SELECT
ISNULL(CAST([campaignId] AS bigint),NULL) AS [campaignId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [addressId]) AS bigint),NULL) AS [addressId]
FROM
SCORE.[dbo].[campaign_address_mapping]
WHERE ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [addressId]) AS bigint),NULL) IS NOT NULL;
GO

print('----Next Table user_customer_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
user_id, customer_id
FROM user_customer_mapping'
)
SELECT
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) AS [customerId]
FROM
SCORE.[dbo].[user_customer_mapping]
WHERE ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) IS NOT NULL;;
GO


print('----Next Table company_location ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, country_id, state_id, updated_by, updated_at, created_by, created_at, deleted_by, deleted_at
FROM company_location'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([countryId] AS bigint),NULL) AS [countryId],
ISNULL(CAST([stateId] AS bigint),NULL) AS [stateId],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt]
FROM
SCORE.[dbo].[company_location];
GO

print('----Next Table department ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, priority, default_ticket_assignee_id, company_location_id, parent_id, deleted_at, deleted_by
FROM department'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(256)),NULL) AS [name],
ISNULL(CAST([priority] AS int),NULL) AS [priority],
NULL AS [defaultTicketAssigneeId],
ISNULL(CAST([companyLocationId] AS bigint),NULL) AS [companyLocationId],
ISNULL(CAST([parentId] AS bigint),NULL) AS [parentId],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[department]
order by parentId;
GO

print('----Next Table employee_department_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, department_id, "from", "until", "primary"
FROM employee_department_mapping'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([departmentId] AS bigint),NULL) AS [departmentId],
ISNULL(CAST([from] AS date),NULL) AS [from],
ISNULL(CAST([until] AS date),NULL) AS [until],
ISNULL(CAST([primary] AS bit),0) AS [primary]
FROM
SCORE.[dbo].[employee_department_mapping];
GO

print('----Next Table option ---');
INSERT OPENQUERY(venabo, 
'SELECT
name, value, type, number_value
FROM option'
)
SELECT
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([value] AS text),NULL) AS [value],
ISNULL(CAST([type] AS nvarchar(64)),NULL) AS [type],
ISNULL(CAST([numberValue] AS float),NULL) AS [numberValue]
FROM
SCORE.[dbo].[option];
GO

print('----Next Table trigger_notification ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, description, type, data, updated_by, updated_at, created_by, created_at, deleted_by, deleted_at, active
FROM trigger_notification'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([description] AS varchar(4000)),NULL) AS [description],
ISNULL(CAST([type] AS nvarchar(510)),NULL) AS [type],
ISNULL(CAST([data] AS varchar(4000)),NULL) AS [data],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([active] AS bit),0) AS [active]
FROM
SCORE.[dbo].[trigger_notification];
GO



print('----Next Table employee_note ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, note, updated_at, updated_by, created_at, created_by
FROM employee_note'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([note] AS varchar(4000)),NULL) AS [note],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy]
FROM
SCORE.[dbo].[employee_note];
GO


print('----Next Table checklist_pattern ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, description, types, items, updated_by, updated_at, created_by, created_at
FROM checklist_pattern'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([description] AS varchar(4000)),NULL) AS [description],
ISNULL(CAST([types] AS varchar(4000)),NULL) AS [types],
ISNULL(CAST([items] AS varchar(4000)),NULL) AS [items],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt]
FROM
SCORE.[dbo].[checklist_pattern];
GO

print('----Next Table employee_notification ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, note, active, "from", "until", updated_at, updated_by, created_at, created_by
FROM employee_notification'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([note] AS varchar(4000)),NULL) AS [note],
ISNULL(CAST([active] AS bit),0) AS [active],
ISNULL(CAST([from] AS datetime2),NULL) AS [from],
ISNULL(CAST([until] AS datetime2),NULL) AS [until],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy]
FROM
SCORE.[dbo].[employee_notification];
GO


print('----Next Table project ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, customer_id, receipt_id, name, settlement_type, calculated_duration, calculated_cost, active, created_at, updated_at, deleted_at, created_by, updated_by, deleted_by, travel_expenses, free_time_surcharge, description, due_date, department_id, parent_id, status_id, start_date, caching_time, progress, cost_article_id, custom_fields
FROM project'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) AS [customerId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[receipt] WHERE [id] = [receiptId]) AS bigint),NULL) AS [receiptId],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([settlementType] AS nvarchar(32)),NULL) AS [settlementType],
ISNULL(CAST([calculatedDuration] AS int),NULL) AS [calculatedDuration],
ISNULL(CAST([calculatedCost] AS decimal),NULL) AS [calculatedCost],
ISNULL(CAST([active] AS bit),0) AS [active],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([travelExpenses] AS tinyint),NULL) AS [travelExpenses],
ISNULL(CAST([freeTimeSurcharge] AS tinyint),NULL) AS [freeTimeSurcharge],
ISNULL(CAST([description] AS nvarchar(4000)),NULL) AS [description],
ISNULL(CAST([dueDate] AS date),NULL) AS [dueDate],
ISNULL(CAST([departmentId] AS bigint),NULL) AS [departmentId],
ISNULL(CAST([parentId] AS bigint),NULL) AS [parentId],
ISNULL(CAST([statusId] AS bigint),NULL) AS [statusId],
ISNULL(CAST([startDate] AS date),NULL) AS [startDate],
ISNULL(CAST([cachingTime] AS datetime2),NULL) AS [cachingTime],
ISNULL(CAST([progress] AS float),NULL) AS [progress],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].article WHERE [id] = [costArticleId]) AS bigint),NULL) AS [costArticleId],
ISNULL(CAST([customFields] AS nvarchar(4000)),NULL) AS [customFields]
FROM
SCORE.[dbo].[project]
where ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) IS NOT NULL
order by case when [parentId] is not null then id else [parentId] end;
GO

print('----Next Table stamp_device ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, type, name, key, active, last_activity, updated_at, updated_by, created_at, created_by, deleted_at, deleted_by, immutable
FROM stamp_device'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([type] AS nvarchar(510)),NULL) AS [type],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([key] AS nvarchar(510)),NULL) AS [key],
ISNULL(CAST([active] AS bit),0) AS [active],
ISNULL(CAST([lastActivity] AS datetime2),NULL) AS [lastActivity],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([immutable] AS bit),0) AS [immutable]
FROM
SCORE.[dbo].[stamp_device];
GO

print('----Next Table employee_stamp_device_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, stamp_device_id, "from", "to"
FROM employee_stamp_device_mapping'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([stampDeviceId] AS bigint),NULL) AS [stampDeviceId],
ISNULL(CAST([from] AS datetime2),NULL) AS [from],
ISNULL(CAST([to] AS datetime2),NULL) AS [to]
FROM
SCORE.[dbo].[employee_stamp_device_mapping];
GO


print('----Next Table service_contract ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, customer_id, name, type, travel_expenses, free_time_surcharge, scheduler_text, scheduler, start_date, next_date, last_date, hits, active, updated_by, updated_at, created_by, created_at, deleted_by, deleted_at, description, positions, total_service_cost, total_travel_cost, receipt_id, caching_time, progress, available_total_cost, used_total_cost, inactive_since
FROM service_contract'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) AS [customerId],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
rtrim(ISNULL(CAST([type] AS nvarchar(32)),NULL)) AS [type],
ISNULL(CAST([travelExpenses] AS tinyint),NULL) AS [travelExpenses],
ISNULL(CAST([freeTimeSurcharge] AS tinyint),NULL) AS [freeTimeSurcharge],
ISNULL(CAST([schedulerText] AS nvarchar(128)),NULL) AS [schedulerText],
ISNULL(CAST([scheduler] AS text),NULL) AS [scheduler],
ISNULL(CAST([startDate] AS date),NULL) AS [startDate],
ISNULL(CAST([nextDate] AS date),NULL) AS [nextDate],
ISNULL(CAST([lastDate] AS date),NULL) AS [lastDate],
ISNULL(CAST([hits] AS int),NULL) AS [hits],
ISNULL(CAST([active] AS bit),0) AS [active],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([description] AS nvarchar(4000)),NULL) AS [description],
ISNULL(CAST([positions] AS nvarchar(4000)),NULL) AS [positions],
ISNULL(CAST([totalServiceCost] AS decimal),NULL) AS [totalServiceCost],
ISNULL(CAST([totalTravelCost] AS decimal),NULL) AS [totalTravelCost],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[receipt] WHERE [id] = [receiptId]) AS bigint),NULL) AS [receiptId],
ISNULL(CAST([cachingTime] AS datetime2),NULL) AS [cachingTime],
ISNULL(CAST([progress] AS float),NULL) AS [progress],
ISNULL(CAST([availableTotalCost] AS decimal),NULL) AS [availableTotalCost],
ISNULL(CAST([usedTotalCost] AS decimal),NULL) AS [usedTotalCost],
ISNULL(CAST([inactiveSince] AS date),NULL) AS [inactiveSince]
FROM
SCORE.[dbo].[service_contract]
where ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) is not null;;
GO


print('----Next Table service_contract_customer_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
service_contract_id, customer_id
FROM service_contract_customer_mapping'
)
SELECT
ISNULL(CAST([serviceContractId] AS bigint),NULL) AS [serviceContractId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) AS [customerId]
FROM
SCORE.[dbo].[service_contract_customer_mapping]
WHERE ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) IS NOT NULL;;
GO

print('----Next Table project_employee_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
project_id, employee_id
FROM project_employee_mapping'
)
SELECT
ISNULL(CAST([projectId] AS bigint),NULL) AS [projectId],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId]
FROM
SCORE.[dbo].[project_employee_mapping];
GO

print('----Next Table time_scheme ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, use_solid_time, solid_allocated_time, updated_at, updated_by, created_at, created_by, deleted_at, deleted_by
FROM time_scheme'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([useSolidTime] AS bit),0) AS [useSolidTime],
ISNULL(CAST([solidAllocatedTime] AS numeric),NULL) AS [solidAllocatedTime],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[time_scheme];
GO

print('----Next Table ticket ---');

WHILE (SELECT count(*) FROM SCORE.[dbo].[ticket] ts)
<> (Select count(*) from OPENQUERY(venabo, 'SELECT id FROM ticket')) 

BEGIN 
INSERT OPENQUERY(venabo, 
'SELECT
id, customer_id, assignee_id, subject, completed_at, completed_by, created_at, updated_at, deleted_at, created_by, updated_by, deleted_by, contact_person, status_id, due_date, due_time, priority_id, department_id, internal, project_id, merged_to, receipt_id
FROM ticket'
)
SELECT TOP 10000
ISNULL(CAST(ticket.[id] AS bigint),NULL) AS [id],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) AS [customerId],
ISNULL(CAST([assigneeId] AS bigint),NULL) AS [assigneeId],
ISNULL(CAST([subject] AS nvarchar(510)),NULL) AS [subject],
ISNULL(CAST([completedAt] AS datetime2),NULL) AS [completedAt],
ISNULL(CAST([completedBy] AS bigint),NULL) AS [completedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([contactPerson] AS nvarchar(510)),NULL) AS [contactPerson],
ISNULL(CAST([statusId] AS bigint),NULL) AS [statusId],
ISNULL(CAST([dueDate] AS date),NULL) AS [dueDate],
ISNULL(CAST([dueTime] AS time),NULL) AS [dueTime],
ISNULL(CAST([priorityId] AS bigint),NULL) AS [priorityId],
ISNULL(CAST([departmentId] AS bigint),NULL) AS [departmentId],
ISNULL(CAST([internal] AS tinyint),NULL) AS [internal],
ISNULL(CAST([projectId] AS bigint),NULL) AS [projectId],
NULL AS [mergedTo],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[receipt] WHERE [id] = [receiptId]) AS bigint),NULL) AS [receiptId]
FROM
SCORE.[dbo].[ticket]
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM ticket'));
END
GO
----Update Table ticket merged_to ---');
UPDATE oq
set oq.merged_to = t.mergedTo
FROM OPENQUERY(venabo, 
'SELECT
id, customer_id, assignee_id, subject, completed_at, completed_by, created_at, updated_at, deleted_at, created_by, updated_by, deleted_by, contact_person, status_id, due_date, due_time, priority_id, department_id, internal, project_id, merged_to, receipt_id
FROM ticket'
) oq
left outer join SCORE.[dbo].[ticket] t on t.id = oq.id
where t.mergedTo is not null


print('----Next Table ticket_assignee_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
ticket_id, assignee_id
FROM ticket_assignee_mapping'
)
SELECT
ISNULL(CAST([ticketId] AS bigint),NULL) AS [ticketId],
ISNULL(CAST([assigneeId] AS bigint),NULL) AS [assigneeId]
FROM
SCORE.[dbo].[ticket_assignee_mapping];
GO

print('----Next Table ticket_offer ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, ticket_id, name, text, settlement_type, calculated_duration, calculated_cost, status, created_at, created_by, accepted_at, accepted_by, rejected_at, rejected_by
FROM ticket_offer'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([ticketId] AS bigint),NULL) AS [ticketId],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([text] AS nvarchar(4000)),NULL) AS [text],
ISNULL(CAST([settlementType] AS nvarchar(64)),NULL) AS [settlementType],
ISNULL(CAST([calculatedDuration] AS int),NULL) AS [calculatedDuration],
ISNULL(CAST([calculatedCost] AS decimal),NULL) AS [calculatedCost],
ISNULL(CAST([status] AS nvarchar(64)),NULL) AS [status],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([acceptedAt] AS datetime2),NULL) AS [acceptedAt],
ISNULL(CAST([acceptedBy] AS bigint),NULL) AS [acceptedBy],
ISNULL(CAST([rejectedAt] AS datetime2),NULL) AS [rejectedAt],
ISNULL(CAST([rejectedBy] AS bigint),NULL) AS [rejectedBy]
FROM
SCORE.[dbo].[ticket_offer];
GO


print('----Next Table ticket_offer_employee_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
offer_id, employee_id
FROM ticket_offer_employee_mapping'
)
SELECT
ISNULL(CAST([offerId] AS bigint),NULL) AS [offerId],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId]
FROM
SCORE.[dbo].[ticket_offer_employee_mapping];
GO


print('----Next Table ticket_subscription ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].[ticket_subscription] ts)
<> (Select count(*) from OPENQUERY(venabo, 'SELECT id FROM ticket_subscription')) 

BEGIN 
INSERT OPENQUERY(venabo, 
'SELECT
id, ticket_id, type, type_id, data, reason_type, created_at, created_by, updated_at, updated_by
FROM ticket_subscription'
)
SELECT top 10000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([ticketId] AS bigint),NULL) AS [ticketId],
ISNULL(CAST([type] AS nvarchar(510)),NULL) AS [type],
ISNULL(CAST([typeId] AS bigint),NULL) AS [typeId],
ISNULL(CAST([data] AS nvarchar(4000)),NULL) AS [data],
ISNULL(CAST([reasonType] AS nvarchar(510)),NULL) AS [reasonType],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy]
FROM
SCORE.[dbo].[ticket_subscription]
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM ticket_subscription'));
END
GO



update oq
set oq.type_id = cp.venaboId
from OPENQUERY(venabo, 
'SELECT
id, ticket_id, type, type_id, data, reason_type, created_at, created_by, updated_at, updated_by
FROM ticket_subscription'
)
oq
left outer join middleware.dbo.contact_person cp
on cp.id = oq.type_id

where
oq.type = 'CONTACT'

GO


print('----Next Table ticket_read_access_log ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].[ticket_read_access_log] ts)
<> (Select count(*) from OPENQUERY(venabo, 'SELECT id FROM ticket_read_access_log'))
BEGIN 
INSERT OPENQUERY(venabo, 
'SELECT
id, user_id, ticket_id, marked_at, type, ignore
FROM ticket_read_access_log'
)
SELECT top 10000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([ticketId] AS bigint),NULL) AS [ticketId],
ISNULL(CAST([markedAt] AS datetime2),NULL) AS [markedAt],
ISNULL(CAST([type] AS nvarchar(510)),NULL) AS [type],
ISNULL(CAST([ignore] AS bit),0) AS [ignore]
FROM
SCORE.[dbo].[ticket_read_access_log]
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM ticket_read_access_log'))
ORDER BY id DESC;
END
GO

print('----Next Table employee_company_location_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, company_location_id, "from", "to"
FROM employee_company_location_mapping'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([companyLocationId] AS bigint),NULL) AS [companyLocationId],
ISNULL(CAST([from] AS date),NULL) AS [from],
ISNULL(CAST([to] AS date),NULL) AS [to]
FROM
SCORE.[dbo].[employee_company_location_mapping];
GO


print('----Next Table trigger_notification_log ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, identifier, trigger_notification_id, object_id, send_at
FROM trigger_notification_log'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([identifier] AS datetime2),NULL) AS [identifier],
ISNULL(CAST([triggerNotificationId] AS bigint),NULL) AS [triggerNotificationId],
ISNULL(CAST([objectId] AS bigint),NULL) AS [objectId],
ISNULL(CAST([sendAt] AS datetime2),NULL) AS [sendAt]
FROM
SCORE.[dbo].[trigger_notification_log];
GO



print('----Next Table delivered_article_settings ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, delivered_article_id, ignored
FROM delivered_article_settings'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[delivered_article] WHERE [id] collate Latin1_General_CS_AS  = [deliveredArticleId] collate Latin1_General_CS_AS ) AS nvarchar(510)),NULL) AS [deliveredArticleId],
ISNULL(CAST([ignored] AS bit),0) AS [ignored]
FROM
SCORE.[dbo].[delivered_article_settings];
GO


print('----Next Table user_option ---');
INSERT OPENQUERY(venabo, 
'SELECT
user_id, name, data
FROM user_option'
)
SELECT
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([data] AS text),NULL) AS [data]
FROM
SCORE.[dbo].[user_option];
GO


print('----Next Table user_permission ---');
INSERT OPENQUERY(venabo, 
'SELECT
user_id, permission_id
FROM user_permission'
)
SELECT
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([permissionId] AS bigint),NULL) AS [permissionId]
FROM
SCORE.[dbo].[user_permission];
GO

print('----Next Table vacation ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, "from", "to", note, half_days, approved, deletion_requested, deleted_at, deleted_by
FROM vacation'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([from] AS date),NULL) AS [from],
ISNULL(CAST([to] AS date),NULL) AS [to],
ISNULL(CAST([note] AS nvarchar(4000)),NULL) AS [note],
ISNULL(CAST([halfDays] AS bit),0) AS [halfDays],
ISNULL(CAST([approved] AS bit),0) AS [approved],
ISNULL(CAST([deletionRequested] AS bit),0) AS [deletionRequested],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[vacation];
GO

print('----Next Table vacation_extra_booking ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, year, days, files, created_at, created_by, updated_at, updated_by, comment
FROM vacation_extra_booking'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([year] AS int),NULL) AS [year],
ISNULL(CAST([days] AS float),NULL) AS [days],
ISNULL(CAST([files] AS tinyint),NULL) AS [files],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([comment] AS nvarchar(4000)),NULL) AS [comment]
FROM
SCORE.[dbo].[vacation_extra_booking];
GO

print('----Next Table exported_receipt ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, customer_id, reference, name, street, zip_code, city, date, total_net_price, created_at, created_by
FROM exported_receipt'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS nvarchar(128)),NULL) AS [customerId],
ISNULL(CAST([reference] AS nvarchar(128)),NULL) AS [reference],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([street] AS nvarchar(256)),NULL) AS [street],
ISNULL(CAST([zipCode] AS nvarchar(128)),NULL) AS [zipCode],
ISNULL(CAST([city] AS nvarchar(256)),NULL) AS [city],
ISNULL(CAST([date] AS date),NULL) AS [date],
ISNULL(CAST([totalNetPrice] AS decimal),NULL) AS [totalNetPrice],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy]
FROM
SCORE.[dbo].[exported_receipt];
GO

print('----Next Table exported_receipt_position ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, receipt_id, article_id, quantity, unit_price, total_net_price, discount, name, description, sequence, processed
FROM exported_receipt_position'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[receipt] WHERE [id] = [receiptId]) AS bigint),NULL) AS [receiptId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[article] WHERE [id] collate Latin1_General_CS_AS = [articleId] collate Latin1_General_CS_AS ) AS nvarchar(128)),NULL) AS [articleId],
ISNULL(CAST([quantity] AS decimal),NULL) AS [quantity],
ISNULL(CAST([unitPrice] AS decimal),NULL) AS [unitPrice],
ISNULL(CAST([totalNetPrice] AS decimal),NULL) AS [totalNetPrice],
ISNULL(CAST([discount] AS decimal),NULL) AS [discount],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([description] AS text),NULL) AS [description],
ISNULL(CAST([sequence] AS int),NULL) AS [sequence],
ISNULL(CAST([processed] AS bit),0) AS [processed]
FROM
SCORE.[dbo].[exported_receipt_position];
GO


print('----Next Table vacation_scheme ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, monday_factor, tuesday_factor, wednesday_factor, thursday_factor, friday_factor, saturday_factor, sunday_factor, num_days
FROM vacation_scheme'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(256)),NULL) AS [name],
ISNULL(CAST([mondayFactor] AS decimal),NULL) AS [mondayFactor],
ISNULL(CAST([tuesdayFactor] AS decimal),NULL) AS [tuesdayFactor],
ISNULL(CAST([wednesdayFactor] AS decimal),NULL) AS [wednesdayFactor],
ISNULL(CAST([thursdayFactor] AS decimal),NULL) AS [thursdayFactor],
ISNULL(CAST([fridayFactor] AS decimal),NULL) AS [fridayFactor],
ISNULL(CAST([saturdayFactor] AS decimal),NULL) AS [saturdayFactor],
ISNULL(CAST([sundayFactor] AS decimal),NULL) AS [sundayFactor],
ISNULL(CAST([numDays] AS decimal),NULL) AS [numDays]
FROM
SCORE.[dbo].[vacation_scheme];
GO

print('----Next Table vacation_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, scheme_id, "from", "to"
FROM vacation_mapping'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([schemeId] AS bigint),NULL) AS [schemeId],
ISNULL(CAST([from] AS date),NULL) AS [from],
ISNULL(CAST([to] AS date),NULL) AS [to]
FROM
SCORE.[dbo].[vacation_mapping];
GO

print('----Next Table fulfillment_type ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, requires_place, duration_mode, travel_duration_mode, travel_article_id
FROM fulfillment_type'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(128)),NULL) AS [name],
ISNULL(CAST([requiresPlace] AS tinyint),NULL) AS [requiresPlace],
ISNULL(CAST([durationMode] AS nvarchar(32)),NULL) AS [durationMode],
ISNULL(CAST([travelDurationMode] AS nvarchar(32)),NULL) AS [travelDurationMode],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[article] WHERE [id] = [travelArticleId]) AS nvarchar(510)),NULL) AS [travelArticleId]
FROM
SCORE.[dbo].[fulfillment_type];
GO

print('----Next Table vacation_year_state ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, year, num_extra_days, num_transferred_days
FROM vacation_year_state'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([year] AS int),NULL) AS [year],
ISNULL(CAST([numExtraDays] AS decimal),NULL) AS [numExtraDays],
ISNULL(CAST([numTransferredDays] AS decimal),NULL) AS [numTransferredDays]
FROM
SCORE.[dbo].[vacation_year_state];
GO

print('----Next Table functional_area ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, deleted_at, deleted_by
FROM functional_area'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(256)),NULL) AS [name],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[functional_area];
GO


print('----Next Table worktime ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, time_scheme_id, "from", "to", time_relevant
FROM worktime'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([timeSchemeId] AS bigint),NULL) AS [timeSchemeId],
ISNULL(CAST([from] AS date),NULL) AS [from],
ISNULL(CAST([to] AS date),NULL) AS [to],
ISNULL(CAST([timeRelevant] AS bit),0) AS [timeRelevant]
FROM
SCORE.[dbo].[worktime];
GO

print('----Next Table functional_area_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, customer_id, functional_area_id, employee_id
FROM functional_area_mapping'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) AS [customerId],
ISNULL(CAST([functionalAreaId] AS bigint),NULL) AS [functionalAreaId],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId]
FROM
SCORE.[dbo].[functional_area_mapping]
WHERE ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) IS NOT NULL;
GO


print('----Next Table report_user_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
report_id, user_id
FROM report_user_mapping'
)
SELECT
ISNULL(CAST([reportId] AS bigint),NULL) AS [reportId],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId]
FROM
SCORE.[dbo].[report_user_mapping];
GO



print('----Next Table holiday ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, "from", "to"
FROM holiday'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(256)),NULL) AS [name],
ISNULL(CAST([from] AS date),NULL) AS [from],
ISNULL(CAST([to] AS date),NULL) AS [to]
FROM
SCORE.[dbo].[holiday];
GO

print('----Next Table illness ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, "from", "to", note, deleted_at, deleted_by
FROM illness'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([from] AS date),NULL) AS [from],
ISNULL(CAST([to] AS date),NULL) AS [to],
ISNULL(CAST([note] AS nvarchar(4000)),NULL) AS [note],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[illness];
GO

print('----Next Table license_hash ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, hash, created_at, created_by, updated_at, updated_by, deleted_at, deleted_by
FROM license_hash'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([hash] AS text),NULL) AS [hash],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[license_hash];
GO


print('----Next Table user_instance_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
user_id, instance_id
FROM user_instance_mapping'
)
SELECT
ISNULL(CAST([user_id] AS bigint),NULL) AS [user_id],
ISNULL(CAST([instance_id] AS bigint),NULL) AS [instance_id]
FROM
SCORE.[dbo].[user_instance_mapping];
GO


print('----Next Table object ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, object_type_id, customer_id, delivered_article_id, name, description, active, contact, department, location, created_at, created_by, updated_at, updated_by, deleted_at, deleted_by, schedule_able
FROM object'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([objectTypeId] AS bigint),NULL) AS [objectTypeId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) AS [customerId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[delivered_article] WHERE [id] = [deliveredArticleId]) AS nvarchar(510)),NULL) AS [deliveredArticleId],
ISNULL(CAST([name] AS nvarchar(256)),'Kein Name vorhanden') AS [name],
ISNULL(CAST([description] AS nvarchar(4000)),NULL) AS [description],
ISNULL(CAST([active] AS bit),0) AS [active],
ISNULL(CAST([contact] AS nvarchar(256)),NULL) AS [contact],
ISNULL(CAST([department] AS nvarchar(256)),NULL) AS [department],
ISNULL(CAST([location] AS nvarchar(256)),NULL) AS [location],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([scheduleAble] AS bit),NULL) AS [scheduleAble]
FROM
SCORE.[dbo].[object]
WHERE ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) IS NOT NULL;
GO

print('----Next Table object_field ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, object_id, object_type_field_id, value
FROM object_field'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([objectId] AS bigint),NULL) AS [objectId],
ISNULL(CAST([objectTypeFieldId] AS bigint),NULL) AS [objectTypeFieldId],
ISNULL(CAST([value] AS nvarchar(510)),NULL) AS [value]
FROM
SCORE.[dbo].[object_field];
GO



print('----Next Table object_object_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
parent_id, child_id
FROM object_object_mapping'
)
SELECT
ISNULL(CAST([parentId] AS bigint),NULL) AS [parentId],
ISNULL(CAST([childId] AS bigint),NULL) AS [childId]
FROM
SCORE.[dbo].[object_object_mapping];
GO


print('----Next Table service_entry ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, "from", "to", receipt_id, user_id, confirmed, checkbox1, checkbox2, note, updated_by, updated_at, created_by, created_at, checkbox_data
FROM service_entry'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([from] AS datetime2),NULL) AS [from],
ISNULL(CAST([to] AS datetime2),NULL) AS [to],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[receipt] WHERE [id] = [receiptId] )AS bigint),NULL) AS [receiptId],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([confirmed] AS bit),0) AS [confirmed],
ISNULL(CAST([checkbox1] AS bit),0) AS [checkbox1],
ISNULL(CAST([checkbox2] AS bit),0) AS [checkbox2],
ISNULL(CAST([note] AS nvarchar(510)),NULL) AS [note],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([checkboxData] AS varchar(4000)),NULL) AS [checkboxData]
FROM
SCORE.[dbo].[service_entry];
GO

print('----Next Table object_project_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
object_id, project_id
FROM object_project_mapping'
)
SELECT
ISNULL(CAST([objectId] AS bigint),NULL) AS [objectId],
ISNULL(CAST([projectId] AS bigint),NULL) AS [projectId]
FROM
SCORE.[dbo].[object_project_mapping];
GO

print('----Next Table service_entry_employee_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
service_entry_id, employee_id
FROM service_entry_employee_mapping'
)
SELECT
ISNULL(CAST([serviceEntryId] AS bigint),NULL) AS [serviceEntryId],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId]
FROM
SCORE.[dbo].[service_entry_employee_mapping];
GO

print('----Next Table object_ticket_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
object_id, ticket_id
FROM object_ticket_mapping'
)
SELECT
ISNULL(CAST([objectId] AS bigint),NULL) AS [objectId],
ISNULL(CAST([ticketId] AS bigint),NULL) AS [ticketId]
FROM
SCORE.[dbo].[object_ticket_mapping];
GO

print('----Next Table object_absence ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, "from", "to", object_id, note, updated_by, updated_at, created_by, created_at
FROM object_absence'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([from] AS datetime2),NULL) AS [from],
ISNULL(CAST([to] AS datetime2),NULL) AS [to],
ISNULL(CAST([objectId] AS bigint),NULL) AS [objectId],
ISNULL(CAST([note] AS nvarchar(510)),NULL) AS [note],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt]
FROM
SCORE.[dbo].[object_absence];
GO


print('----Next Table object_service_entry ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, "from", "to", customer_id, receipt_id, user_id, confirmed, checkbox1, checkbox2, note, updated_by, updated_at, created_by, created_at, checkbox_data
FROM object_service_entry'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([from] AS datetime2),NULL) AS [from],
ISNULL(CAST([to] AS datetime2),NULL) AS [to],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) AS [customerId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[receipt] WHERE [id] = [receiptId]) AS bigint),NULL) AS [receiptId],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([confirmed] AS bit),0) AS [confirmed],
ISNULL(CAST([checkbox1] AS bit),0) AS [checkbox1],
ISNULL(CAST([checkbox2] AS bit),0) AS [checkbox2],
ISNULL(CAST([note] AS nvarchar(510)),NULL) AS [note],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([checkboxData] AS varchar(4000)),NULL) AS [checkboxData]
FROM
SCORE.[dbo].[object_service_entry];
GO

INSERT OPENQUERY(venabo, 
'SELECT
id, name, background_color,  text_color, deleted_at, deleted_by
FROM color'
)
SELECT ISNULL(CAST([id] AS bigint),NULL) AS [id],
      [name]
      ,[background_color]
      ,[text_color],
ISNULL(CAST([deleted_at] AS datetime2),NULL) AS [deleted_at],
ISNULL(CAST([deleted_by] AS bigint),NULL) AS [deleted_by]
FROM SCORE.[dbo].[color];

  GO


print('----Next Table operation_schedule ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, object_type, object_id, employee_id, "from", "to", created_at, created_by, updated_at, updated_by, fixed, workload, confirmed, color_id
FROM operation_schedule'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([objectType] AS nvarchar(510)),NULL) AS [objectType],
ISNULL(CAST([objectId] AS bigint),NULL) AS [objectId],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([from] AS datetime2),NULL) AS [from],
ISNULL(CAST([to] AS datetime2),NULL) AS [to],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([fixed] AS bit),0) AS [fixed],
ISNULL(CAST([workload] AS int),NULL) AS [workload],
ISNULL(CAST([confirmed] AS bit),0) AS [confirmed],
[color_id]
FROM
SCORE.[dbo].[operation_schedule];
GO


print('----Next Table phone_call ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].[phone_call])
<> (Select count(*) from OPENQUERY(venabo, 'SELECT id FROM phone_call'))
BEGIN
INSERT OPENQUERY(venabo, 
'SELECT
id, "time", duration, address_id, contact_id, contact_phone_number, employee_id, employee_user_name, employee_phone_number, acceptor_id, acceptor_user_name, direction, accepted_call, external_source, external_key, created_at, created_by, updated_at, updated_by, deleted_at, deleted_by
FROM phone_call'
)
SELECT TOP 10000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([time] AS datetime),NULL) AS [time],
ISNULL(CAST([duration] AS int),NULL) AS [duration],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [addressId]) AS bigint),NULL) AS [addressId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[contact_person] WHERE [id] = [contactId]) AS bigint),NULL) AS [contactId],
ISNULL(CAST([contactPhoneNumber] AS varchar(255)),NULL) AS [contactPhoneNumber],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([employeeUserName] AS varchar(255)),NULL) AS [employeeUserName],
ISNULL(CAST([employeePhoneNumber] AS varchar(255)),NULL) AS [employeePhoneNumber],
ISNULL(CAST([acceptorId] AS bigint),NULL) AS [acceptorId],
ISNULL(CAST([acceptorUserName] AS varchar(255)),NULL) AS [acceptorUserName],
ISNULL(CAST([direction] AS nvarchar(6)),NULL) AS [direction],
ISNULL(CAST([acceptedCall] AS tinyint),NULL) AS [acceptedCall],
ISNULL(CAST([externalSource] AS nvarchar(128)),NULL) AS [externalSource],
ISNULL(CAST([externalKey] AS nvarchar(510)),NULL) AS [externalKey],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[phone_call]
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM phone_call'));
END;
GO



print('----Next Table object_service_entry_object_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
object_service_entry_id, object_id
FROM object_service_entry_object_mapping'
)
SELECT
ISNULL(CAST([objectServiceEntryId] AS bigint),NULL) AS [objectServiceEntryId],
ISNULL(CAST([objectId] AS bigint),NULL) AS [objectId]
FROM
SCORE.[dbo].[object_service_entry_object_mapping];
GO


print('----Next Table process ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].[process])
<> (Select count(*) from OPENQUERY(venabo, 'SELECT id FROM process'))
BEGIN
INSERT OPENQUERY(venabo, 
'SELECT
id, address_id, subject, completed_at, completed_by, created_at, updated_at, deleted_at, created_by, updated_by, deleted_by, contact_person, status_id, ticket_id, receipt_id, process_category_id, process_category_child_id, resubmission_date, resubmission_time, merged_to, campaign_id
FROM process'
)
SELECT TOP 10000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [addressId]) AS bigint),NULL) AS [addressId],
ISNULL(CAST([subject] AS nvarchar(510)),NULL) AS [subject],
ISNULL(CAST([completedAt] AS datetime2),NULL) AS [completedAt],
ISNULL(CAST([completedBy] AS bigint),NULL) AS [completedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([contactPerson] AS nvarchar(510)),NULL) AS [contactPerson],
ISNULL(CAST([statusId] AS bigint),NULL) AS [statusId],
ISNULL(CAST([ticketId] AS bigint),NULL) AS [ticketId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[receipt] WHERE [id] = [receiptId]) AS bigint),NULL) AS [receiptId],
ISNULL(CAST([processCategoryId] AS bigint),NULL) AS [processCategoryId],
ISNULL(CAST([processCategoryChildId] AS bigint),NULL) AS [processCategoryChildId],
ISNULL(CAST([resubmissionDate] AS date),NULL) AS [resubmissionDate],
ISNULL(CAST([resubmissionTime] AS time),NULL) AS [resubmissionTime],
NULL AS [mergedTo],
ISNULL(CAST([campaignId] AS bigint),NULL) AS [campaignId]
FROM
SCORE.[dbo].[process]
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM process'));
END;
GO

----Update Table ticket merged_to ---');
UPDATE oq
set oq.merged_to = t.mergedTo
FROM OPENQUERY(venabo, 
'SELECT
id, merged_to
FROM process'
) oq
left outer join SCORE.[dbo].[process] t on t.id = oq.id
where t.mergedTo is not null



print('----Next Table process_assignee_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
process_id, assignee_id
FROM process_assignee_mapping'
)
SELECT
ISNULL(CAST([processId] AS bigint),NULL) AS [processId],
ISNULL(CAST([assigneeId] AS bigint),NULL) AS [assigneeId]
FROM
SCORE.[dbo].[process_assignee_mapping];
GO

print('----Next Table checklist ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].[checklist])
<> (Select count(*) from OPENQUERY(venabo, 'SELECT id FROM checklist'))
BEGIN
INSERT OPENQUERY(venabo, 
'SELECT
id, name, description, object_type, object_id, updated_by, updated_at, created_by, created_at
FROM checklist'
)
SELECT TOP 1000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([description] AS varchar(4000)),NULL) AS [description],
ISNULL(CAST([objectType] AS nvarchar(510)),NULL) AS [objectType],
ISNULL(CAST([objectId] AS bigint),NULL) AS [objectId],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt]
FROM
SCORE.[dbo].[checklist]
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM checklist'));
END
GO

print('----Next Table stamp_type ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, active, outgoing, color, updated_at, updated_by, created_at, created_by, deleted_at, deleted_by, break, worktime_relevant
FROM stamp_type'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([active] AS bit),0) AS [active],
ISNULL(CAST([outgoing] AS bit),0) AS [outgoing],
ISNULL(CAST([color] AS nvarchar(510)),NULL) AS [color],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([break] AS bit),0) AS [break],
ISNULL(CAST([worktimeRelevant] AS bit),0) AS [worktimeRelevant]
FROM
SCORE.[dbo].[stamp_type];
GO

print('----Next Table process_entry ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].[process_entry])
<> (Select count(*) from OPENQUERY(venabo, 'SELECT id FROM process_entry'))
BEGIN
INSERT OPENQUERY(venabo, 
'SELECT
id, process_id, user_id, comment, changelog, created_at, status_id, type, html_formatted, modified_at, pinned, email
FROM process_entry'
)
SELECT TOP 10000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([processId] AS bigint),NULL) AS [processId],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([comment] AS nvarchar(4000)),NULL) AS [comment],
ISNULL(CAST([changelog] AS nvarchar(4000)),NULL) AS [changelog],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([statusId] AS bigint),NULL) AS [statusId],
ISNULL(CAST([type] AS nvarchar(64)),NULL) AS [type],
ISNULL(CAST([htmlFormatted] AS bit),0) AS [htmlFormatted],
ISNULL(CAST([modifiedAt] AS datetime2),NULL) AS [modifiedAt],
ISNULL(CAST([pinned] AS bit),0) AS [pinned],
ISNULL(CAST([email] AS nvarchar(510)),NULL) AS [email]
FROM
SCORE.[dbo].[process_entry]
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM process_entry'));
END;
GO

print('----Next Table checklist_item ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, checklist_id, name, description, due_date_time, checked, done_by, done_at, created_by
FROM checklist_item'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([checklistId] AS bigint),NULL) AS [checklistId],
ISNULL(CAST([name] AS varchar(4000)),NULL) AS [name],
ISNULL(CAST([description] AS varchar(4000)),NULL) AS [description],
ISNULL(CAST([dueDateTime] AS datetime2),NULL) AS [dueDateTime],
ISNULL(CAST([checked] AS bit),0) AS [checked],
ISNULL(CAST([doneBy] AS bigint),NULL) AS [doneBy],
ISNULL(CAST([doneAt] AS datetime2),NULL) AS [doneAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy]
FROM
SCORE.[dbo].[checklist_item];
GO


print('----Next Table process_filter ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, filter, user_id, created_at
FROM process_filter'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([filter] AS text),NULL) AS [filter],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt]
FROM
SCORE.[dbo].[process_filter];
GO

print('----Next Table process_subscription ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].[process_subscription])
<> (Select count(*) from OPENQUERY(venabo, 'SELECT id FROM process_subscription'))
BEGIN
INSERT OPENQUERY(venabo, 
'SELECT
id, process_id, type, type_id, data, reason_type, created_at, created_by, updated_at, updated_by
FROM process_subscription'
)
SELECT TOP 10000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([processId] AS bigint),NULL) AS [processId],
ISNULL(CAST([type] AS nvarchar(510)),NULL) AS [type],
ISNULL(CAST([typeId] AS bigint),NULL) AS [typeId],
ISNULL(CAST([data] AS nvarchar(4000)),NULL) AS [data],
ISNULL(CAST([reasonType] AS nvarchar(510)),NULL) AS [reasonType],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy]
FROM
SCORE.[dbo].[process_subscription]
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM process_subscription'));
END;
GO


print('----Next Table checklist_item_assignee_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
checklist_item_id, assignee_id
FROM checklist_item_assignee_mapping'
)
SELECT
ISNULL(CAST([checklistItemId] AS bigint),NULL) AS [checklistItemId],
ISNULL(CAST([assigneeId] AS bigint),NULL) AS [assigneeId]
FROM
SCORE.[dbo].[checklist_item_assignee_mapping];
GO

print('----Next Table oauth_token ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, provider, access_token, refresh_token, expires, resource_owner_id, complete_data, updated_by, updated_at, created_by, created_at
FROM oauth_token'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([provider] AS nvarchar(4000)),NULL) AS [provider],
ISNULL(CAST([accessToken] AS nvarchar(4000)),NULL) AS [accessToken],
ISNULL(CAST([refreshToken] AS nvarchar(4000)),NULL) AS [refreshToken],
ISNULL(CAST([expires] AS bigint),NULL) AS [expires],
ISNULL(CAST([resourceOwnerId] AS nvarchar(4000)),NULL) AS [resourceOwnerId],
ISNULL(CAST([completeData] AS varchar(4000)),NULL) AS [completeData],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt]
FROM
SCORE.[dbo].[oauth_token];
GO


print('----Next Table service_contract_manual_booking ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, service_contract_id, name, value, type, created_at, created_by, updated_at, updated_by
FROM service_contract_manual_booking'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([serviceContractId] AS bigint),NULL) AS [serviceContractId],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([value] AS decimal),NULL) AS [value],
ISNULL(CAST([type] AS nchar(32)),NULL) AS [type],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy]
FROM
SCORE.[dbo].[service_contract_manual_booking];
GO


print('----Next Table time_scheme_day ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, time_scheme_id, shift_id, weekday, "start", "end", worktime, core_time_start, core_time_end, allowed_time_start, allowed_time_end, absence_time, holiday_time, round_before_start, round_after_start, round_before_end, round_after_end, round_incoming_threshold, round_incoming_value, round_outgoing_threshold, round_outgoing_value, round_settings
FROM time_scheme_day'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([timeSchemeId] AS bigint),NULL) AS [timeSchemeId],
ISNULL(CAST([shiftId] AS bigint),NULL) AS [shiftId],
ISNULL(CAST([weekday] AS bigint),NULL) AS [weekday],
ISNULL(CAST([start] AS time),NULL) AS [start],
ISNULL(CAST([end] AS time),NULL) AS [end],
ISNULL(CAST([worktime] AS bigint),NULL) AS [worktime],
ISNULL(CAST([coreTimeStart] AS time),NULL) AS [coreTimeStart],
ISNULL(CAST([coreTimeEnd] AS time),NULL) AS [coreTimeEnd],
ISNULL(CAST([allowedTimeStart] AS time),NULL) AS [allowedTimeStart],
ISNULL(CAST([allowedTimeEnd] AS time),NULL) AS [allowedTimeEnd],
ISNULL(CAST([absenceTime] AS bigint),NULL) AS [absenceTime],
ISNULL(CAST([holidayTime] AS bigint),NULL) AS [holidayTime],
ISNULL(CAST([roundBeforeStart] AS bigint),NULL) AS [roundBeforeStart],
ISNULL(CAST([roundAfterStart] AS bigint),NULL) AS [roundAfterStart],
ISNULL(CAST([roundBeforeEnd] AS bigint),NULL) AS [roundBeforeEnd],
ISNULL(CAST([roundAfterEnd] AS bigint),NULL) AS [roundAfterEnd],
ISNULL(CAST([roundIncomingThreshold] AS bigint),NULL) AS [roundIncomingThreshold],
ISNULL(CAST([roundIncomingValue] AS bigint),NULL) AS [roundIncomingValue],
ISNULL(CAST([roundOutgoingThreshold] AS bigint),NULL) AS [roundOutgoingThreshold],
ISNULL(CAST([roundOutgoingValue] AS bigint),NULL) AS [roundOutgoingValue],
ISNULL(CAST([roundSettings] AS varchar(4000)),NULL) AS [roundSettings]
FROM
SCORE.[dbo].[time_scheme_day];
GO


print('----Next Table time_scheme_day_break ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, time_scheme_day_id, "start", "end"
FROM time_scheme_day_break'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([timeSchemeDayId] AS bigint),NULL) AS [timeSchemeDayId],
ISNULL(CAST([start] AS time),NULL) AS [start],
ISNULL(CAST([end] AS time),NULL) AS [end]
FROM
SCORE.[dbo].[time_scheme_day_break];
GO

print('----Next Table tag_process_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
tag_id, process_id
FROM tag_process_mapping'
)
SELECT
ISNULL(CAST([tagId] AS bigint),NULL) AS [tagId],
ISNULL(CAST([processId] AS bigint),NULL) AS [processId]
FROM
SCORE.[dbo].[tag_process_mapping];
GO


print('----Next Table time_scheme_day_threshold ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, time_scheme_day_id, after_time, break_duration, insert_before
FROM time_scheme_day_threshold'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([timeSchemeDayId] AS bigint),NULL) AS [timeSchemeDayId],
ISNULL(CAST([afterTime] AS bigint),NULL) AS [afterTime],
ISNULL(CAST([breakDuration] AS bigint),NULL) AS [breakDuration],
ISNULL(CAST([insertBefore] AS bit),NULL) AS [insertBefore]
FROM
SCORE.[dbo].[time_scheme_day_threshold];
GO


print('----Next Table task ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, service_contract_id, name, description, fixed_due_date, scheduler, current_log_id, created_at, created_by, updated_at, updated_by, deleted_at, deleted_by, last_log_id
FROM task'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([serviceContractId] AS bigint),NULL) AS [serviceContractId],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([description] AS nvarchar(4000)),NULL) AS [description],
ISNULL(CAST([fixedDueDate] AS tinyint),NULL) AS [fixedDueDate],
ISNULL(CAST([scheduler] AS nvarchar(510)),NULL) AS [scheduler],
ISNULL(CAST([currentLogId] AS bigint),NULL) AS [currentLogId],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([lastLogId] AS bigint),NULL) AS [lastLogId]
FROM
SCORE.[dbo].[task];
GO

print('----Next Table task_employee_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
task_id, employee_id
FROM task_employee_mapping'
)
SELECT
ISNULL(CAST([taskId] AS bigint),NULL) AS [taskId],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId]
FROM
SCORE.[dbo].[task_employee_mapping];
GO

print('----Next Table task_log ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].[task_log])
<> (Select count(*) from OPENQUERY(venabo, 'SELECT id FROM task_log'))
BEGIN
INSERT OPENQUERY(venabo, 
'SELECT
id, task_id, "date", due_from, due_to, "status", completed_at, completed_by
FROM task_log'
)
SELECT TOP 10000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([taskId] AS bigint),NULL) AS [taskId],
ISNULL(CAST([date] AS date),NULL) AS [date],
ISNULL(CAST([dueFrom] AS date),NULL) AS [dueFrom],
ISNULL(CAST([dueTo] AS date),NULL) AS [dueTo],
ISNULL(CAST([status] AS nvarchar(64)),NULL) AS [status],
ISNULL(CAST([completedAt] AS datetime2),NULL) AS [completedAt],
ISNULL(CAST([completedBy] AS bigint),NULL) AS [completedBy]
FROM
SCORE.[dbo].[task_log]
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM task_log'));
END;
GO

print('----Next Table process_read_access_log ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].process_read_access_log)
<> (Select count(*) from OPENQUERY(venabo, 'SELECT id FROM process_read_access_log'))
BEGIN
INSERT OPENQUERY(venabo, 
'SELECT
id, user_id, process_id, marked_at, type, ignore
FROM process_read_access_log'
)
SELECT TOP 10000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([processId] AS bigint),NULL) AS [processId],
ISNULL(CAST([markedAt] AS datetime2),NULL) AS [markedAt],
ISNULL(CAST([type] AS nvarchar(510)),NULL) AS [type],
ISNULL(CAST([ignore] AS bit),0) AS [ignore]
FROM
SCORE.[dbo].[process_read_access_log]
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM process_read_access_log'));
END
GO


print('----Next Table holiday_company_location_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
holiday_id, company_location_id
FROM holiday_company_location_mapping'
)
SELECT
ISNULL(CAST([holidayId] AS bigint),NULL) AS [holidayId],
ISNULL(CAST([companyLocationId] AS bigint),NULL) AS [companyLocationId]
FROM
SCORE.[dbo].[holiday_company_location_mapping];
GO


print('----Next Table employee_worktime_account_booking ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, "type", "date", "value", updated_at, updated_by, created_at, created_by, deleted_at, deleted_by, note
FROM employee_worktime_account_booking'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([type] AS nvarchar(510)),NULL) AS [type],
ISNULL(CAST([date] AS date),NULL) AS [date],
ISNULL(CAST([value] AS float),NULL) AS [value],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([note] AS varchar(4000)),NULL) AS [note]
FROM
SCORE.[dbo].[employee_worktime_account_booking];
GO

/*
print('----Next Table employee_worktime_account_processed ---');
INSERT OPENQUERY(venabo, 
'SELECT
date, employee_id, value
FROM employee_worktime_account_processed'
)
SELECT
ISNULL(CAST([date] AS date),NULL) AS [date],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([value] AS bigint),NULL) AS [value]
FROM
SCORE.[dbo].[employee_worktime_account_processed];
GO
*/

print('----Next Table employee_auth ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, "type", "from", "to", updated_at, updated_by, created_at, created_by, deleted_at, deleted_by, data_identifier, data_secret, data_additional
FROM employee_auth'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([type] AS nvarchar(510)),NULL) AS [type],
ISNULL(CAST([from] AS date),NULL) AS [from],
ISNULL(CAST([to] AS date),NULL) AS [to],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([dataIdentifier] AS nvarchar(510)),NULL) AS [dataIdentifier],
ISNULL(CAST([dataSecret] AS nvarchar(510)),NULL) AS [dataSecret],
ISNULL(CAST([dataAdditional] AS nvarchar(510)),NULL) AS [dataAdditional]
FROM
SCORE.[dbo].[employee_auth];
GO

print('----Next Table employee_article_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, fulfillment_type_id, article_id
FROM employee_article_mapping'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([fulfillmentTypeId] AS bigint),NULL) AS [fulfillmentTypeId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[article] WHERE [id] collate Latin1_General_CS_AS = [articleId] collate Latin1_General_CS_AS ) AS nvarchar(128)),NULL) AS [articleId]
FROM
SCORE.[dbo].[employee_article_mapping];
GO

print('----Next Table department_vacation_manage_employee_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
employee_id, department_id
FROM department_vacation_manage_employee_mapping'
)
SELECT
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([departmentId] AS bigint),NULL) AS [departmentId]
FROM
SCORE.[dbo].[department_vacation_manage_employee_mapping];
GO


WHILE (SELECT count(*) FROM SCORE.[dbo].[time_entry])
<>(Select count(*) from OPENQUERY(venabo, 'SELECT id FROM time_entry'))
BEGIN  
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, customer_id, project_id, service_contract_id, date, duration, fulfillment_type_id, fulfillment_place, traveling_expenses_type, traveling_expenses_km, traveling_expenses_flat_price, traveling_duration, billable, free_time_surcharge, contact_person, description, comment, status, updated_by, updated_at, created_by, created_at, approved_by, approved_at, completed_by, completed_at, transferred_by, transferred_at, ticket_id, timer_duration, task_id, task_log_id, task_completed, duration_mode, teamviewer_connection_id, blocked
FROM time_entry'
)
SELECT top 10000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) AS [customerId],
ISNULL(CAST([projectId] AS bigint),NULL) AS [projectId],
ISNULL(CAST([serviceContractId] AS bigint),NULL) AS [serviceContractId],
ISNULL(CAST([date] AS date),NULL) AS [date],
ISNULL(CAST([duration] AS int),NULL) AS [duration],
ISNULL(CAST([fulfillmentTypeId] AS bigint),NULL) AS [fulfillmentTypeId],
ISNULL(CAST([fulfillmentPlace] AS nvarchar(510)),NULL) AS [fulfillmentPlace],
ISNULL(CAST([travelingExpensesType] AS nchar(2)),NULL) AS [travelingExpensesType],
ISNULL(CAST([travelingExpensesKm] AS decimal),NULL) AS [travelingExpensesKm],
ISNULL(CAST([travelingExpensesFlatPrice] AS decimal),NULL) AS [travelingExpensesFlatPrice],
ISNULL(CAST([travelingDuration] AS int),NULL) AS [travelingDuration],
ISNULL(CAST([billable] AS bit),0) AS [billable],
ISNULL(CAST([freeTimeSurcharge] AS tinyint),NULL) AS [freeTimeSurcharge],
ISNULL(CAST([contactPerson] AS nvarchar(510)),NULL) AS [contactPerson],
ISNULL(CAST([description] AS nvarchar(4000)),NULL) AS [description],
ISNULL(CAST([comment] AS nvarchar(4000)),NULL) AS [comment],
ISNULL(CAST([status] AS nvarchar(32)),NULL) AS [status],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([approvedBy] AS bigint),NULL) AS [approvedBy],
ISNULL(CAST([approvedAt] AS datetime2),NULL) AS [approvedAt],
ISNULL(CAST([completedBy] AS bigint),NULL) AS [completedBy],
ISNULL(CAST([completedAt] AS datetime2),NULL) AS [completedAt],
ISNULL(CAST([transferredBy] AS bigint),NULL) AS [transferredBy],
ISNULL(CAST([transferredAt] AS datetime2),NULL) AS [transferredAt],
ISNULL(CAST([ticketId] AS bigint),NULL) AS [ticketId],
ISNULL(CAST([timerDuration] AS int),NULL) AS [timerDuration],
ISNULL(CAST([taskId] AS bigint),NULL) AS [taskId],
ISNULL(CAST([taskLogId] AS bigint),NULL) AS [taskLogId],
ISNULL(CAST([taskCompleted] AS tinyint),NULL) AS [taskCompleted],
ISNULL(CAST([durationMode] AS nvarchar(32)),NULL) AS [durationMode],
ISNULL(CAST([teamviewerConnectionId] AS bigint),NULL) AS [teamviewerConnectionId],
ISNULL(CAST([blocked] AS bit),0) AS [blocked]
FROM
SCORE.[dbo].[time_entry]
WHERE ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[address] WHERE [id] = [customerId]) AS bigint),NULL) IS NOT NULL
AND id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM time_entry'));
END

GO


print('----Next Table ticket_entry ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].[ticket_entry])
<>(Select count(*) from OPENQUERY(venabo, 'SELECT id FROM ticket_entry'))
BEGIN  
INSERT OPENQUERY(venabo, 
'SELECT
id, ticket_id, user_id, time_entry_id, comment, changelog, created_at, status_id, offer_id, type, internal, object_id, object_action, html_formatted, pinned, email
FROM ticket_entry'
)
SELECT TOP 10000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([ticketId] AS bigint),NULL) AS [ticketId],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([timeEntryId] AS bigint),NULL) AS [timeEntryId],
ISNULL(CAST([comment] AS nvarchar(4000)),NULL) AS [comment],
ISNULL(CAST([changelog] AS nvarchar(4000)),NULL) AS [changelog],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([statusId] AS bigint),NULL) AS [statusId],
ISNULL(CAST([offerId] AS bigint),NULL) AS [offerId],
ISNULL(CAST([type] AS nvarchar(64)),NULL) AS [type],
ISNULL(CAST([internal] AS bit),0) AS [internal],
ISNULL(CAST([objectId] AS bigint),NULL) AS [objectId],
ISNULL(CAST([objectAction] AS tinyint),NULL) AS [objectAction],
ISNULL(CAST([htmlFormatted] AS tinyint),NULL) AS [htmlFormatted],
ISNULL(CAST([pinned] AS bit),0) AS [pinned],
ISNULL(CAST([email] AS nvarchar(510)),NULL) AS [email]
FROM
SCORE.[dbo].[ticket_entry]
WHERE id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM ticket_entry'))
END;
GO

print('----Next Table time_entry_time ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].[time_entry_time])
<>(Select count(*) from OPENQUERY(venabo, 'SELECT id FROM time_entry_time'))
BEGIN 
INSERT OPENQUERY(venabo, 
'SELECT
id, time_entry_id, start_time, end_time, duration
FROM time_entry_time'
)
SELECT TOP 10000
ISNULL(CAST(tet.[id] AS bigint),NULL) AS [id],
ISNULL(CAST([timeEntryId] AS bigint),NULL) AS [timeEntryId],
ISNULL(CAST([startTime] AS time),NULL) AS [startTime],
ISNULL(CAST([endTime] AS time),NULL) AS [endTime],
ISNULL(CAST([duration] AS int),NULL) AS [duration]
FROM
SCORE.[dbo].[time_entry_time] tet
left outer join (Select id from OPENQUERY(venabo, 'SELECT id FROM time_entry_time')) oq on oq.id = tet.id
where oq.id is null
END;
GO



print('----Next Table time_entry_article ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, time_entry_id, article_id, quantity
FROM time_entry_article'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([timeEntryId] AS bigint),NULL) AS [timeEntryId],
ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[article] WHERE [id] collate Latin1_General_CS_AS = [articleId] collate Latin1_General_CS_AS ) AS nvarchar(128)),NULL) AS [articleId],
ISNULL(CAST([quantity] AS decimal),NULL) AS [quantity]
FROM
SCORE.[dbo].[time_entry_article]
where ISNULL(CAST((SELECT [venaboId] FROM [middleware].[dbo].[article] WHERE [id] collate Latin1_General_CS_AS = [articleId] collate Latin1_General_CS_AS ) AS nvarchar(128)),NULL) is not null;
GO



print('----Next Table dashlet_option_group_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
dashlet_option_id, group_id
FROM dashlet_option_group_mapping'
)
SELECT
ISNULL(CAST([dashletOptionId] AS bigint),NULL) AS [dashletOptionId],
ISNULL(CAST([groupId] AS bigint),NULL) AS [groupId]
FROM
SCORE.[dbo].[dashlet_option_group_mapping];
GO

print('----Next Table dashlet_option_user_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
dashlet_option_id, user_id
FROM dashlet_option_user_mapping'
)
SELECT
ISNULL(CAST([dashletOptionId] AS bigint),NULL) AS [dashletOptionId],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId]
FROM
SCORE.[dbo].[dashlet_option_user_mapping];
GO

print('----Next Table enumeration ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, type, name, icon, is_default, sequence, created_by, created_at
FROM enumeration'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([type] AS nvarchar(64)),NULL) AS [type],
ISNULL(CAST([name] AS nvarchar(128)),NULL) AS [name],
ISNULL(CAST([icon] AS nvarchar(128)),NULL) AS [icon],
ISNULL(CAST([isDefault] AS tinyint),NULL) AS [isDefault],
ISNULL(CAST([sequence] AS int),NULL) AS [sequence],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt]
FROM
SCORE.[dbo].[enumeration];
GO

print('----Next Table tag_ticket_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
tag_id, ticket_id
FROM tag_ticket_mapping'
)
SELECT
ISNULL(CAST([tagId] AS bigint),NULL) AS [tagId],
ISNULL(CAST([ticketId] AS bigint),NULL) AS [ticketId]
FROM
SCORE.[dbo].[tag_ticket_mapping];
GO

print('----Next Table wage_type ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, name, description, number, export_key, print, export, min, max, count_from, rounding, value_type, factor, updated_at, updated_by, created_at, created_by, deleted_at, deleted_by
FROM wage_type'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([description] AS varchar(4000)),NULL) AS [description],
ISNULL(CAST([number] AS nvarchar(510)),NULL) AS [number],
ISNULL(CAST([exportKey] AS nvarchar(510)),NULL) AS [exportKey],
ISNULL(CAST([print] AS bit),NULL) AS [print],
ISNULL(CAST([export] AS bit),NULL) AS [export],
ISNULL(CAST([min] AS bigint),NULL) AS [min],
ISNULL(CAST([max] AS bigint),NULL) AS [max],
ISNULL(CAST([countFrom] AS bigint),NULL) AS [countFrom],
ISNULL(CAST([rounding] AS bigint),NULL) AS [rounding],
ISNULL(CAST([valueType] AS nvarchar(510)),NULL) AS [valueType],
ISNULL(CAST([factor] AS float),NULL) AS [factor],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[wage_type];
GO

print('----Next Table wage_type_block ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, wage_type_id, name, min, max, count_from, value_type, operator, updated_at, updated_by, created_at, created_by, deleted_at, deleted_by
FROM wage_type_block'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([wageTypeId] AS bigint),NULL) AS [wageTypeId],
ISNULL(CAST([name] AS nvarchar(510)),NULL) AS [name],
ISNULL(CAST([min] AS bigint),NULL) AS [min],
ISNULL(CAST([max] AS bigint),NULL) AS [max],
ISNULL(CAST([countFrom] AS bigint),NULL) AS [countFrom],
ISNULL(CAST([valueType] AS nvarchar(510)),NULL) AS [valueType],
ISNULL(CAST([operator] AS nvarchar(2)),NULL) AS [operator],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[wage_type_block];
GO

print('----Next Table wage_type_block_item ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, wage_type_block_id, type, type_filter, "from", "to", started_previous_day, weekday, interval, interval_settings, min, max, count_from, operator, updated_at, updated_by, created_at, created_by, deleted_at, deleted_by
FROM wage_type_block_item'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([wageTypeBlockId] AS bigint),NULL) AS [wageTypeBlockId],
ISNULL(CAST([type] AS nvarchar(510)),NULL) AS [type],
ISNULL(CAST([typeFilter] AS varchar(4000)),NULL) AS [typeFilter],
ISNULL(CAST([from] AS time),NULL) AS [from],
ISNULL(CAST([to] AS time),NULL) AS [to],
ISNULL(CAST([startedPreviousDay] AS bit),NULL) AS [startedPreviousDay],
ISNULL(CAST([weekday] AS smallint),NULL) AS [weekday],
ISNULL(CAST([interval] AS nvarchar(510)),NULL) AS [interval],
ISNULL(CAST([intervalSettings] AS varchar(4000)),NULL) AS [intervalSettings],
ISNULL(CAST([min] AS bigint),NULL) AS [min],
ISNULL(CAST([max] AS bigint),NULL) AS [max],
ISNULL(CAST([countFrom] AS bigint),NULL) AS [countFrom],
ISNULL(CAST([operator] AS nvarchar(255)),NULL) AS [operator],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy]
FROM
SCORE.[dbo].[wage_type_block_item];
GO


print('----Next Table employee_wage_type_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, wage_type_id, "from", "to"
FROM employee_wage_type_mapping'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([wageTypeId] AS bigint),NULL) AS [wageTypeId],
ISNULL(CAST([from] AS datetime2),NULL) AS [from],
ISNULL(CAST([to] AS datetime2),NULL) AS [to]
FROM
SCORE.[dbo].[employee_wage_type_mapping];
GO

print('----Next Table stamp_type_device_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, stamp_type_id, stamp_device_id, "from", "to"
FROM stamp_type_device_mapping'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([stampTypeId] AS bigint),NULL) AS [stampTypeId],
ISNULL(CAST([stampDeviceId] AS bigint),NULL) AS [stampDeviceId],
ISNULL(CAST([from] AS datetime2),NULL) AS [from],
ISNULL(CAST([to] AS datetime2),NULL) AS [to]
FROM
SCORE.[dbo].[stamp_type_device_mapping];
GO

print('----Next Table stamp ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].stamp
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM stamp'))
) >0  
BEGIN 
INSERT OPENQUERY(venabo, 
'SELECT
id, time, employee_id, type_id, updated_at, updated_by, created_at, created_by, deleted_at, deleted_by, stamp_device_id, identifier, ignore
FROM stamp'
)
SELECT TOP 1000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([time] AS datetime2),NULL) AS [time],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([typeId] AS bigint),NULL) AS [typeId],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([updatedBy] AS bigint),NULL) AS [updatedBy],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt],
ISNULL(CAST([deletedBy] AS bigint),NULL) AS [deletedBy],
ISNULL(CAST([stampDeviceId] AS bigint),NULL) AS [stampDeviceId],
ISNULL(CAST([identifier] AS nvarchar(510)),NULL) AS [identifier],
ISNULL(CAST([ignore] AS bit),0) AS [ignore]
FROM
SCORE.[dbo].[stamp]
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM stamp'));
END;
GO



print('----Next Table employee_rfid_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, employee_id, identifier, "from", "to"
FROM employee_rfid_mapping'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([identifier] AS nvarchar(510)),NULL) AS [identifier],
ISNULL(CAST([from] AS datetime2),NULL) AS [from],
ISNULL(CAST([to] AS datetime2),NULL) AS [to]
FROM
SCORE.[dbo].[employee_rfid_mapping];
GO

print('----Next Table employee_time_recording_options ---');
INSERT OPENQUERY(venabo, 
'SELECT
employee_id, monthly_settlement_type, included_overtime_hours, capture_edit_permission, order_recording_type, max_overtime
FROM employee_time_recording_options'
)
SELECT
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([monthlySettlementType] AS nvarchar(510)),NULL) AS [monthlySettlementType],
ISNULL(CAST([includedOvertimeHours] AS numeric),NULL) AS [includedOvertimeHours],
ISNULL(CAST([captureEditPermission] AS varchar(4000)),NULL) AS [captureEditPermission],
ISNULL(CAST([orderRecordingType] AS nvarchar(510)),NULL) AS [orderRecordingType],
ISNULL(CAST([maxOvertime] AS bigint),NULL) AS [maxOvertime]
FROM
SCORE.[dbo].[employee_time_recording_options];
GO

print('----Next Table object_time_entry_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
object_id, time_entry_id
FROM object_time_entry_mapping'
)
SELECT
ISNULL(CAST([objectId] AS bigint),NULL) AS [objectId],
ISNULL(CAST([timeEntryId] AS bigint),NULL) AS [timeEntryId]
FROM
SCORE.[dbo].[object_time_entry_mapping];
GO

print('----Next Table object_task_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
object_id, task_id
FROM object_task_mapping'
)
SELECT
ISNULL(CAST([objectId] AS bigint),NULL) AS [objectId],
ISNULL(CAST([taskId] AS bigint),NULL) AS [taskId]
FROM
SCORE.[dbo].[object_task_mapping];
GO

print('----Next Table object_service_contract_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
object_id, service_contract_id
FROM object_service_contract_mapping'
)
SELECT
ISNULL(CAST([objectId] AS bigint),NULL) AS [objectId],
ISNULL(CAST([serviceContractId] AS bigint),NULL) AS [serviceContractId]
FROM
SCORE.[dbo].[object_service_contract_mapping];
GO

print('----Next Table chat_conversation ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, updated_at, created_at
FROM chat_conversation'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([updatedAt] AS datetime2),NULL) AS [updatedAt],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt]
FROM
SCORE.[dbo].[chat_conversation];
GO

print('----Next Table employee_employee_notification_mapping ---');
INSERT OPENQUERY(venabo, 
'SELECT
employee_id, employee_notification_id
FROM employee_employee_notification_mapping'
)
SELECT
ISNULL(CAST([employeeId] AS bigint),NULL) AS [employeeId],
ISNULL(CAST([employeeNotificationId] AS bigint),NULL) AS [employeeNotificationId]
FROM
SCORE.[dbo].[employee_employee_notification_mapping];
GO

print('----Next Table chat_conversation_participant ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, conversation_id, user_id, deleted_at
FROM chat_conversation_participant'
)
SELECT
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([conversationId] AS bigint),NULL) AS [conversationId],
ISNULL(CAST([userId] AS bigint),NULL) AS [userId],
ISNULL(CAST([deletedAt] AS datetime2),NULL) AS [deletedAt]
FROM
SCORE.[dbo].[chat_conversation_participant];
GO

print('----Next Table chat_message ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].chat_message)
<> (Select count(*) from OPENQUERY(venabo, 'SELECT id FROM chat_message'))
BEGIN 
INSERT OPENQUERY(venabo, 
'SELECT
id, conversation_id, sender_id, message, object_type, object_id, send_at, encrypted, seen_at
FROM chat_message'
)
SELECT TOP 1000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([conversationId] AS bigint),NULL) AS [conversationId],
ISNULL(CAST([senderId] AS bigint),NULL) AS [senderId],
ISNULL(CAST([message] AS varchar(4000)),NULL) AS [message],
ISNULL(CAST([objectType] AS nvarchar(510)),NULL) AS [objectType],
ISNULL(CAST([objectId] AS bigint),NULL) AS [objectId],
ISNULL(CAST([sendAt] AS datetime2),NULL) AS [sendAt],
ISNULL(CAST([encrypted] AS bit),0) AS [encrypted],
ISNULL(CAST([seenAt] AS datetime2),NULL) AS [seenAt]
FROM
SCORE.[dbo].[chat_message]
where id not in (
Select id from OPENQUERY(venabo, 'SELECT id FROM chat_message'));
END;
GO

print('----Update Table department ---');
UPDATE oq
set oq.default_ticket_assignee_id = d.[defaultTicketAssigneeId]
FROM OPENQUERY(venabo, 
'SELECT
* FROM department'
) oq
left outer join SCORE.[dbo].department d on d.id = oq.id

GO

update oq
set oq.custom_fields = cast(cast(ad.customFields as nvarchar(max)) as text)
--set oq.custom_fields = NULL
from OPENQUERY(venabo, 
'SELECT
*
FROM address'
) oq
left outer join middleware.dbo.address a on a.venaboId = oq.id
left outer join SCORE.dbo.address ad on ad.id = a.id
where ad.customFields is not null

GO
delete from OPENQUERY(venabo, 
'SELECT
*
FROM group_permission'
)

delete from OPENQUERY(venabo, 
'SELECT
*
FROM user_permission'
)

delete from OPENQUERY(venabo, 
'SELECT
*
FROM permission'
)


print('----Next Table permission ---');
INSERT OPENQUERY(venabo, 
'SELECT
id, role, name, permission_group, "type"
FROM permission'
)
SELECT [id]
      ,[role]
      ,[name]
      ,[permission_group]
	  ,'USER' as 'type'
  FROM SCORE.[dbo].[permission];
GO


print('----Next Table group_permission ---');
INSERT OPENQUERY(venabo, 
'SELECT
group_id, permission_id
FROM group_permission'
)
SELECT
ISNULL(CAST([groupId] AS bigint),NULL) AS [groupId],
ISNULL(CAST(gp.permissionId AS bigint),NULL) AS [permissionId]
FROM
SCORE.[dbo].[group_permission] gp



print('----Next Table user_permission ---');
INSERT OPENQUERY(venabo, 
'SELECT
user_id, permission_id
FROM user_permission'
)
SELECT
ISNULL(CAST(userId AS bigint),NULL) AS [groupId],
ISNULL(CAST(gp.permissionId AS bigint),NULL) AS [permissionId]
FROM
SCORE.[dbo].[user_permission] gp


 INSERT INTO job
 (
 class
      ,state
      ,priority
      ,created_at
      ,started_at
      ,closed_at
      ,args
      ,output
      ,runtime
 )

 SELECT 
      'App\AppBundle\Domain\Stamp\Job\RefreshStampProcessedJob' as "class"
      ,'PENDING' as "state"
      ,1 as "priority"
      ,'2019-01-03' as "created_at"
      ,NULL as "started_at"
      ,NULL as "closed_at"
      ,'{"employeeId":' || cast(e.id as varchar(400)) || ',"date": "2018-01-01" }' as args
      ,NULL as output
      ,NULL as runtime
  FROM job j
  right join employee e on NULL = NULL
  where e.id in (Select employee_id from worktime where time_relevant = true)


/*
print('----Next Table log ---');
WHILE (SELECT count(*) FROM SCORE.[dbo].[log]
where id not in (
Select old_id from OPENQUERY(venabo, 'SELECT old_id FROM log') where old_id is not null)
) >0  
BEGIN  
INSERT OPENQUERY(venabo, 
'SELECT
old_id, action, object_type, object_id, data, revertable, created_at, created_by
FROM log'
)
SELECT top 1000
ISNULL(CAST([id] AS bigint),NULL) AS [id],
ISNULL(CAST([action] AS nvarchar(510)),NULL) AS [action],
ISNULL(CAST([objectType] AS nvarchar(510)),NULL) AS [objectType],
ISNULL(CAST([objectId] AS nvarchar(510)),NULL) AS [objectId],
ISNULL(CAST([data] AS nvarchar(4000)),NULL) AS [data],
ISNULL(CAST([revertable] AS bit),0) AS [revertable],
ISNULL(CAST([createdAt] AS datetime2),NULL) AS [createdAt],
ISNULL(CAST([createdBy] AS bigint),NULL) AS [createdBy]
FROM
SCORE.[dbo].[log]
where id not in (
Select old_id from OPENQUERY(venabo, 'SELECT old_id FROM log') where old_id is not null);
END
GO
*/

---Foldendes SQL nach Migration auf Postgre durchführen---
/*
CREATE OR REPLACE FUNCTION "reset_sequence" (tablename text, columnname text, sequence_name text) RETURNS "pg_catalog"."void" AS 
    $body$  
      DECLARE 
      BEGIN 
      EXECUTE 'SELECT setval( ''' || sequence_name  || ''', ' || '(SELECT MAX(' || columnname || ') FROM "' || tablename || '")' || '+1)';
      END;  
    $body$  LANGUAGE 'plpgsql';

select table_name || '_' || column_name || '_seq' , reset_sequence(table_name, column_name, table_name || '_' || column_name || '_seq') 
from information_schema.columns where column_default like 'nextval%'
and table_name not in ('');

ALTER TABLE "task"
									ADD CONSTRAINT "fk_task_last_log_id"
									FOREIGN KEY ("last_log_id")
									REFERENCES "task_log" ("id")
									
ALTER TABLE "task"
									ADD CONSTRAINT "fk_task_current_log_id"
									FOREIGN KEY ("current_log_id")
									REFERENCES "task_log" ("id")									

*/